/*===========================================================================
 *
 * File:	Dfexport3dsdialog.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Monday, March 25, 2002
 *
 * Handles a simple dialog displayed when exporting multiple 3DS files.
 *
 *=========================================================================*/
#ifndef __DFEXPORT3DSDIALOG_H
#define __DFEXPORT3DSDIALOG_H


/*===========================================================================
 *
 * Required Include Files
 *
 *=========================================================================*/
  #include "dl_mem.h"
/*===========================================================================
 *		End of Required Include Files
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CDfExport3dsDialog Definition
 *
 *=========================================================================*/
class CDfExport3dsDialog : public CDialog {

  /*---------- Begin Protected Class Members -----------------------*/
protected:

  //{{AFX_DATA(CDfExport3dsDialog)
	enum { IDD = IDD_EXPORT3DS_DIALOG };
	CButton	m_CancelButton;
  int		m_NumExportFiles;
  CEdit		m_ExportLabel;
  CProgressCtrl	m_ExportProgress;
	//}}AFX_DATA


  /*--------- Begin Public Class Methods --------------------------*/
public:

	/* Class Constructor */
  CDfExport3dsDialog(CWnd* pParent = NULL);

	/* Initialize the dialog */
  void InitDialog (const int NumExportFiles);

	/* Update the dialog */
  int UpdateProgress (const char* pFilename, const int NumExported, const int NumFailed);


	/* ClassWizard generated virtual function overrides */
  //{{AFX_VIRTUAL(CDfExport3dsDialog)
protected:
  virtual void DoDataExchange(CDataExchange* pDX);
  //}}AFX_VIRTUAL

protected:

	/* Generated message map functions */
  //{{AFX_MSG(CDfExport3dsDialog) 
	virtual BOOL OnInitDialog();
	virtual void OnCancel();
	//}}AFX_MSG

  DECLARE_MESSAGE_MAP()

 };
/*===========================================================================
 *		End of Class CDfExport3dsDialog Definition
 *=========================================================================*/





//{{AFX_INSERT_LOCATION}}
//}}AFX_INSERT_LOCATION


#endif
/*===========================================================================
 *		End of File Dfexport3dsdialog.H
 *=========================================================================*/
