/*===========================================================================
 *
 * File:	Dfto3dsview.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Saturday, June 23, 2001
 *
 * Description
 *
 *=========================================================================*/
#ifndef __DFTO3DSVIEW_H
#define __DFTO3DSVIEW_H

	
/*===========================================================================
 *
 * Class CDfto3dsView Definition
 *
 *=========================================================================*/
class CDfto3dsView : public CFormView {

protected:

	/* Create from serialization only */
  CDfto3dsView();
  DECLARE_DYNCREATE(CDfto3dsView)

public:
  //{{AFX_DATA(CDfto3dsView)
  enum { IDD = IDD_DFTO3DS_FORM };
  CEdit		m_Data1OffsetText;
  CEdit		m_NormalsOffsetText;
  CEdit		m_PointOffsetText;
  CEdit		m_Data2OffsetText;
  CEdit		m_FaceOffsetText;
  CEdit		m_Data2CountText;
  CEdit		m_FaceCountText;
  CEdit		m_PointCountText;
  CEdit		m_VersionText;
  CEdit		m_SizeText;
  CEdit		m_OffsetText;
  CEdit		m_ValueText;
  CListBox	m_ObjectList;
  //}}AFX_DATA


public:
  CDfto3dsDoc* GetDocument();

	/* Check the currently selected item in list for validity */
  boolean IsSelectedObjectValid (void);

	/* Update the object texts */
  void ClearObjectTexts (void);
  void SetObjectTexts   (const int Index);

	/* Update the Arch3D object list */
  void CreateObjectList (void);

	/* ClassWizard generated virtual function overrides */
  //{{AFX_VIRTUAL(CDfto3dsView)
public:
  virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
  virtual void DoDataExchange(CDataExchange* pDX);
  virtual void OnInitialUpdate();
  virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
  //}}AFX_VIRTUAL


public:
  virtual ~CDfto3dsView();

#ifdef _DEBUG
  virtual void AssertValid() const;
  virtual void Dump(CDumpContext& dc) const;
#endif

	/* Generated message map functions */
protected:
  //{{AFX_MSG(CDfto3dsView)
  afx_msg void OnSelchangeArch3dobjectList();
  afx_msg void OnUpdateFileExportdxf(CCmdUI* pCmdUI);
  afx_msg void OnFileExportdxf();
  afx_msg void OnFileExport3ds();
  afx_msg void OnFileExportAll3ds ();
  afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
  afx_msg LRESULT OnHelpHitTest(WPARAM, LPARAM lParam);
  //}}AFX_MSG

  DECLARE_MESSAGE_MAP()

 };
/*===========================================================================
 *		End of Class CDfto3dsView
 *=========================================================================*/


/*===========================================================================
 *
 * Begin CDfto3dsView Inline Methods
 *
 *=========================================================================*/
#ifndef _DEBUG 
  inline CDfto3dsDoc* CDfto3dsView::GetDocument() { return (CDfto3dsDoc*)m_pDocument; }
#endif
/*===========================================================================
 *		End of CDfto3dsView Inline Methods
 *=========================================================================*/


//{{AFX_INSERT_LOCATION}}
//}}AFX_INSERT_LOCATION

#endif
/*===========================================================================
 *		End of File Dfto3dsview.H
 *=========================================================================*/
